function ThankOmat() {
	this.ajaxRequest = null;
	this.postID = 0;
	this.containers = new Object();
	this.language = new Object();

	this.showHideThankUser = function(postID) {
		document.getElementById('thankStatsLink-'+postID).blur();
		var element = $('thankUser-'+postID);
		if (element == null) {
			return;
		}
		
		if (element.visible()) {
			element.blindUp({
				duration: Math.sqrt(element.getHeight())/40
			});
		}
		else {
			element.blindDown({
				duration: Math.sqrt(element.getHeight())/40
			});
		}
	}
	
	this.onError = function(message) {
		alert(message);
		if (this.postID) {
			var thankPostButtons = document.getElementsByName("thankPostButton" + this.postID);
			for (var i=0; i < thankPostButtons.length; i++) {
				var element = $(thankPostButtons[i].parentNode);

				if (element.visible()) {
					element.hide();
				}
			}
		}
	}

	this.thankPost = function(postID) {
		if (this.ajaxRequest != null) return false;
		this.ajaxRequest = new AjaxRequest();
		this.postID = postID;
		if (this.ajaxRequest.openGet('index.php?action=Thank&output=xml&postID='+postID+'&t='+SECURITY_TOKEN+SID_ARG_2ND, this.handleResponse)) {
			var imgs = document.getElementsByName('thankImg'+postID);
			for (var i = 0; i < imgs.length; i++) {
				imgs[i].src = imgs[i].src.replace(/thankS\.png/, 'thankLoadS.gif');
				imgs[i].src = imgs[i].src.replace(/thankM\.png/, 'thankLoadM.gif');
			}
			return true;
		} else {
			this.ajaxRequest = null;
			this.postID = 0;
			return false;
		}
	}

	this.deleteThank = function(postID, userID) {
		if (this.ajaxRequest != null) return false;
		this.ajaxRequest = new AjaxRequest();
		this.postID = postID;
		if (this.ajaxRequest.openGet('index.php?action=ThankDelete&output=xml&userID='+userID+'&postID='+postID+'&t='+SECURITY_TOKEN+SID_ARG_2ND, this.handleResponse)) {
			var imgs = document.getElementsByName('thankImg'+postID);
			for (var i = 0; i < imgs.length; i++) {
				imgs[i].src = imgs[i].src.replace(/thankLoadS\.gif/, 'thankS.png');
				imgs[i].src = imgs[i].src.replace(/thankLoadM\.gif/, 'thankM.png');
			}
			return true;
		} else {
			this.ajaxRequest = null;
			this.postID = 0;
			return false;
		}
	}
	
	this.handleResponse = function() {
		if (thankOmat.ajaxRequest.xmlHttpRequest.readyState == 4) {
			if (thankOmat.ajaxRequest.xmlHttpRequest.status != 200) {
				// throw an exception
				thankOmat.onError('ajax request http error '+thankOmat.ajaxRequest.xmlHttpRequest.status);
			} else {
				var xml = thankOmat.ajaxRequest.xmlHttpRequest.responseXML;
				if (!xml || thankOmat.ajaxRequest.xmlHttpRequest.responseText.indexOf('<?xml') < 0) {
					thankOmat.onError(thankOmat.ajaxRequest.xmlHttpRequest.responseText);
				} else {
					// posts
					var redoImageResize = false;
					var posts = xml.getElementsByTagName("post");
					for (var i = 0; i < posts.length; i++) {
						var post = posts[i];
						var postID = 0;
						for (var j = 0; j < post.attributes.length; j++) {
							if (post.attributes[j].name == 'postID')
								postID = post.attributes[j].value;
						}
						if (postID == 0) continue;
						for (var j = 0; j < post.childNodes.length; j++) {
							if (post.childNodes[j].nodeName == "postText" && document.getElementById('postText'+postID)) {
								document.getElementById('postText'+postID).innerHTML = post.childNodes[j].firstChild.nodeValue;
								redoImageResize = true;
							} else if (post.childNodes[j].nodeName == "postThankStats") {
								var userDiv = document.getElementById('thankUser-'+postID);
								var oldClassName = '';
								if (userDiv) oldClassName = userDiv.className;

								var div = $('thankStats'+postID);
								if (post.childNodes[j].firstChild.nodeValue == '')
									div.blindUp();
								else if (!div.visible()) {
									div.innerHTML = post.childNodes[j].firstChild.nodeValue;
									div.blindDown();
								}
								else {
									div.innerHTML = post.childNodes[j].firstChild.nodeValue;
								}

								if (userDiv) userDiv.className = oldClassName;
							}
						}
					}

					// thank stats
					var userThanks = xml.getElementsByTagName("userThanks");
					for (var i = 0; i < userThanks.length; i++) {
						var userID = 0;
						for (var j = 0; j < userThanks[i].attributes.length; j++) {
							if (userThanks[i].attributes[j].name == 'userID')
								userID = userThanks[i].attributes[j].value;
						}

						if (thankOmat.containers[userID]) {
							for (var j = 0; j < thankOmat.containers[userID].length; j++) {
								var element = $(thankOmat.containers[userID][j]);

								if (userThanks[i].firstChild.nodeValue == '')
									element.blindUp();
								else if (element.innerHTML == '' || !element.visible()) {
									element.hide();
									element.innerHTML = userThanks[i].firstChild.nodeValue;
									element.blindDown();
								}
								else
									element.innerHTML = userThanks[i].firstChild.nodeValue;
							}
						}
					}

					// scripts
					var scripts = xml.getElementsByTagName("script");
					for (var i = 0; i < scripts.length; i++) {
						eval(scripts[i].firstChild.nodeValue);
					}

					// Hide Button
					thankOmat.toogleButton(thankOmat.postID);
					if (redoImageResize && ImageResizer != undefined) {
						new ImageResizer();
					}
				}
			}
			thankOmat.ajaxRequest = null;
			thankOmat.postID = 0;
		}
	}
	
	this.toogleButton = function(postID) {
		var thankPostButtons = document.getElementsByName("thankPostButton" + postID);
		for (var i=0; i < thankPostButtons.length; i++) {
			var element = $(thankPostButtons[i].parentNode);

			if (element.visible()) {
				element.fade({
					duration: 0.8
				});
			}
			else {
				element.appear({
					duration: 0.8
				});
			}
		}
	}

	this.addCreditContainer = function(userID, containerID) {
		if (!this.containers[userID]) {
			this.containers[userID] = new Array();
		}
		this.containers[userID][this.containers[userID].length] = containerID;
	}
}

var thankOmat = new ThankOmat();